//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

#define IMAGE_WIDTH 200
#define IMAGE_HEIGHT 200
#define IMAGE_INTERVAL 4
#define LABEL_WIDTH IMAGE_WIDTH
#define LABEL_HEIGHT 17

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   int i=0, j=0, k=0;
   TColor Color;
   BYTE bRGB;

   for(i=7; i>=0; i--)
   {
      Graphics::TBitmap *bmp=new Graphics::TBitmap;
      bmp->Width=ImageSrc->Width;
      bmp->Height=ImageSrc->Height;

      bmp->PixelFormat=pf24bit;
      bmp->Canvas->Brush->Color=clWhite;
      bmp->Canvas->FillRect(Rect(0, 0, bmp->Width, bmp->Height));

      for(j=0; j<bmp->Width; j++)
      {
         for(k=0; k<bmp->Height; k++)
         {
            Color=ImageSrc->Canvas->Pixels[j][k];
            bRGB=GetRValue(Color);
//            bRGB=GetGValue(Color);
//            bRGB=GetBValue(Color);
            bmp->Canvas->Pixels[j][k]=((bRGB>>i) & 0x01)? clWhite: clBlack;
            Application->ProcessMessages();
         }
      }
//      bmp->SaveToFile("bmp"+IntToStr(i)+".bmp");

      switch(i)
      {
         case 7:
            Image7->Picture->Bitmap->Assign(bmp);
            break;
         case 6:
            Image6->Picture->Bitmap->Assign(bmp);
            break;
         case 5:
            Image5->Picture->Bitmap->Assign(bmp);
            break;
         case 4:
            Image4->Picture->Bitmap->Assign(bmp);
            break;
         case 3:
            Image3->Picture->Bitmap->Assign(bmp);
            break;
         case 2:
            Image2->Picture->Bitmap->Assign(bmp);
            break;
         case 1:
            Image1->Picture->Bitmap->Assign(bmp);
            break;
         case 0:
            Image0->Picture->Bitmap->Assign(bmp);
            break;
      }
      delete bmp;
      Application->ProcessMessages();
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   //---------------------------------------------------------------------------
   // Set LabelSrc's attributes
   LabelSrc->Width=LABEL_WIDTH;
   LabelSrc->Height=LABEL_HEIGHT;
   LabelSrc->Left=IMAGE_INTERVAL;
   LabelSrc->Top=IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set ImageSrc's attributes
   ImageSrc->Left=IMAGE_INTERVAL;
   ImageSrc->Top=LabelSrc->Top+LabelSrc->Height;
   ImageSrc->Width=IMAGE_WIDTH;
   ImageSrc->Height=IMAGE_HEIGHT;
   ImageSrc->Stretch=true;
   ImageSrc->Picture->Bitmap->LoadFromFile("Lenna_24Bit_200x200.bmp");

   //---------------------------------------------------------------------------
   // Set Label7's attributes
   Label7->Width=LABEL_WIDTH;
   Label7->Height=LABEL_HEIGHT;
   Label7->Left=LabelSrc->Left+LabelSrc->Width+IMAGE_INTERVAL;
   Label7->Top=IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Image7's attributes
   Image7->Left=ImageSrc->Left+ImageSrc->Width+IMAGE_INTERVAL;
   Image7->Top=Label7->Top+Label7->Height;
   Image7->Width=IMAGE_WIDTH;
   Image7->Height=IMAGE_HEIGHT;
   Image7->Stretch=true;

   //---------------------------------------------------------------------------
   // Set Label6's attributes
   Label6->Width=LABEL_WIDTH;
   Label6->Height=LABEL_HEIGHT;
   Label6->Left=Label7->Left+Label7->Width+IMAGE_INTERVAL;
   Label6->Top=IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Image6's attributes
   Image6->Left=Image7->Left+Image7->Width+IMAGE_INTERVAL;
   Image6->Top=Label6->Top+Label6->Height;
   Image6->Width=IMAGE_WIDTH;
   Image6->Height=IMAGE_HEIGHT;
   Image6->Stretch=true;

   //---------------------------------------------------------------------------
   // Set Label5's attributes
   Label5->Width=LABEL_WIDTH;
   Label5->Height=LABEL_HEIGHT;
   Label5->Left=Label6->Left+Label6->Width+IMAGE_INTERVAL;
   Label5->Top=IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Image5's attributes
   Image5->Left=Image6->Left+Image6->Width+IMAGE_INTERVAL;
   Image5->Top=Label5->Top+Label5->Height;
   Image5->Width=IMAGE_WIDTH;
   Image5->Height=IMAGE_HEIGHT;
   Image5->Stretch=true;

   //---------------------------------------------------------------------------
   // Set Label4's attributes
   Label4->Width=LABEL_WIDTH;
   Label4->Height=LABEL_HEIGHT;
   Label4->Left=Label5->Left+Label5->Width+IMAGE_INTERVAL;
   Label4->Top=IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Image4's attributes
   Image4->Left=Image5->Left+Image5->Width+IMAGE_INTERVAL;
   Image4->Top=Label4->Top+Label4->Height;
   Image4->Width=IMAGE_WIDTH;
   Image4->Height=IMAGE_HEIGHT;
   Image4->Stretch=true;

   //---------------------------------------------------------------------------
   // Set LabelDst's attributes
   LabelDst->Width=LABEL_WIDTH;
   LabelDst->Height=LABEL_HEIGHT;
   LabelDst->Left=IMAGE_INTERVAL;
   LabelDst->Top=ImageSrc->Top+ImageSrc->Height+IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set ImageDst's attributes
   ImageDst->Left=IMAGE_INTERVAL;
   ImageDst->Top=LabelDst->Top+LabelDst->Height;
   ImageDst->Width=IMAGE_WIDTH;
   ImageDst->Height=IMAGE_HEIGHT;
   ImageDst->Stretch=true;

   //---------------------------------------------------------------------------
   // Set Label3's attributes
   Label3->Width=LABEL_WIDTH;
   Label3->Height=LABEL_HEIGHT;
   Label3->Left=LabelDst->Left+LabelDst->Width+IMAGE_INTERVAL;
   Label3->Top=Image7->Top+Image7->Height+IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Image3's attributes
   Image3->Left=ImageDst->Left+ImageDst->Width+IMAGE_INTERVAL;
   Image3->Top=Label3->Top+Label3->Height;
   Image3->Width=IMAGE_WIDTH;
   Image3->Height=IMAGE_HEIGHT;
   Image3->Stretch=true;

   //---------------------------------------------------------------------------
   // Set Label2's attributes
   Label2->Width=LABEL_WIDTH;
   Label2->Height=LABEL_HEIGHT;
   Label2->Left=Label3->Left+Label3->Width+IMAGE_INTERVAL;
   Label2->Top=Image6->Top+Image6->Height+IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Image2's attributes
   Image2->Left=Image3->Left+Image3->Width+IMAGE_INTERVAL;
   Image2->Top=Label2->Top+Label2->Height;
   Image2->Width=IMAGE_WIDTH;
   Image2->Height=IMAGE_HEIGHT;
   Image2->Stretch=true;

   //---------------------------------------------------------------------------
   // Set Label1's attributes
   Label1->Width=LABEL_WIDTH;
   Label1->Height=LABEL_HEIGHT;
   Label1->Left=Label2->Left+Label2->Width+IMAGE_INTERVAL;
   Label1->Top=Image5->Top+Image5->Height+IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Image1's attributes
   Image1->Left=Image2->Left+Image2->Width+IMAGE_INTERVAL;
   Image1->Top=Label1->Top+Label1->Height;
   Image1->Width=IMAGE_WIDTH;
   Image1->Height=IMAGE_HEIGHT;
   Image1->Stretch=true;

   //---------------------------------------------------------------------------
   // Set Label0's attributes
   Label0->Width=LABEL_WIDTH;
   Label0->Height=LABEL_HEIGHT;
   Label0->Left=Label1->Left+Label1->Width+IMAGE_INTERVAL;
   Label0->Top=Image4->Top+Image4->Height+IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Image0's attributes
   Image0->Left=Image1->Left+Image1->Width+IMAGE_INTERVAL;
   Image0->Top=Label0->Top+Label0->Height;
   Image0->Width=IMAGE_WIDTH;
   Image0->Height=IMAGE_HEIGHT;
   Image0->Stretch=true;

   //--------------------------------------------------------------------------
   // Set Form1's attributes
   Form1->ClientWidth=ImageSrc->Width+Image7->Width+Image6->Width+Image5->Width+
      Image4->Width+6*IMAGE_INTERVAL;
   Form1->ClientHeight=ImageSrc->Height+ImageDst->Height+LabelSrc->Height+
      LabelDst->Height+Button1->Height+5*IMAGE_INTERVAL;
   Form1->Left=(Screen->Width-Form1->Width)/2;
   Form1->Top=(Screen->Height-Form1->Height)/2;

   //---------------------------------------------------------------------------
   // Set Button1's attributes
   Button1->Left=Form1->ClientWidth-Button1->Width-IMAGE_INTERVAL;
   Button1->Top=Form1->ClientHeight-Button1->Height-IMAGE_INTERVAL;

   //---------------------------------------------------------------------------
   // Set Button2's attributes
   Button2->Left=Button1->Left-Button2->Width-IMAGE_INTERVAL;
   Button2->Top=Button1->Top;

   //---------------------------------------------------------------------------
   // Set Button3's attributes
   Button3->Left=Button2->Left-Button3->Width-IMAGE_INTERVAL;
   Button3->Top=Button2->Top;

   //---------------------------------------------------------------------------
   // Set Button4's attributes
   Button4->Left=Button3->Left-Button4->Width-IMAGE_INTERVAL;
   Button4->Top=Button3->Top;

   Button4->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Image1->Canvas->Font->Name="з";
   Image1->Canvas->Font->Size=64;
   Image1->Canvas->TextOut(60, 60, "]");
//   Image1->Picture->Bitmap->SaveToFile("bmp1-1.bmp");
   Image0->Canvas->Font->Name="з";
   Image0->Canvas->Font->Size=64;
   Image0->Canvas->TextOut(60, 60, "l");
//   Image0->Picture->Bitmap->SaveToFile("bmp0-1.bmp");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
   int i=0, j=0;
   BYTE Bit7, Bit6, Bit5, Bit4, Bit3, Bit2, Bit1, Bit0;
   BYTE bRGB=0;
   TColor Color;

   Graphics::TBitmap *bmp=new Graphics::TBitmap;
   bmp->Width=ImageDst->Width;
   bmp->Height=ImageDst->Height;
   bmp->PixelFormat=pf24bit;
   for(i=0; i<bmp->Width; i++)
   {
      for(j=0; j<bmp->Height; j++)
      {
         Color=ImageSrc->Canvas->Pixels[i][j];
         Bit7=(Image7->Canvas->Pixels[i][j]==clWhite)? 0x80: 0;
         Bit6=(Image6->Canvas->Pixels[i][j]==clWhite)? 0x40: 0;
         Bit5=(Image5->Canvas->Pixels[i][j]==clWhite)? 0x20: 0;
         Bit4=(Image4->Canvas->Pixels[i][j]==clWhite)? 0x10: 0;
         Bit3=(Image3->Canvas->Pixels[i][j]==clWhite)? 0x08: 0;
         Bit2=(Image2->Canvas->Pixels[i][j]==clWhite)? 0x04: 0;
         Bit1=(Image1->Canvas->Pixels[i][j]==clWhite)? 0x02: 0;
         Bit0=(Image0->Canvas->Pixels[i][j]==clWhite)? 0x01: 0;
         bRGB=Bit7 | Bit6 | Bit5 | Bit4 | Bit3 | Bit2 | Bit1 | Bit0;
         bmp->Canvas->Pixels[i][j]=(TColor)RGB(bRGB, GetGValue(Color), GetBValue(Color));
//         bmp->Canvas->Pixels[i][j]=(TColor)RGB(GetRValue(Color), bRGB, GetBValue(Color));
//         bmp->Canvas->Pixels[i][j]=(TColor)RGB(GetRValue(Color), GetGValue(Color), bRGB);
         Application->ProcessMessages();
      }
   }
   ImageDst->Picture->Bitmap->Assign(bmp);
   delete bmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
   ImageDst->Canvas->Brush->Color=clWhite;
   ImageDst->Canvas->FillRect(Rect(0, 0, ImageDst->Width, ImageDst->Height));
   Image7->Canvas->Brush->Color=clWhite;
   Image7->Canvas->FillRect(Rect(0, 0, Image7->Width, Image7->Height));
   Image6->Canvas->Brush->Color=clWhite;
   Image6->Canvas->FillRect(Rect(0, 0, Image6->Width, Image6->Height));
   Image5->Canvas->Brush->Color=clWhite;
   Image5->Canvas->FillRect(Rect(0, 0, Image5->Width, Image5->Height));
   Image4->Canvas->Brush->Color=clWhite;
   Image4->Canvas->FillRect(Rect(0, 0, Image4->Width, Image4->Height));
   Image3->Canvas->Brush->Color=clWhite;
   Image3->Canvas->FillRect(Rect(0, 0, Image3->Width, Image3->Height));
   Image2->Canvas->Brush->Color=clWhite;
   Image2->Canvas->FillRect(Rect(0, 0, Image2->Width, Image2->Height));
   Image1->Canvas->Brush->Color=clWhite;
   Image1->Canvas->FillRect(Rect(0, 0, Image1->Width, Image1->Height));
   Image0->Canvas->Brush->Color=clWhite;
   Image0->Canvas->FillRect(Rect(0, 0, Image0->Width, Image0->Height));
}
//---------------------------------------------------------------------------
